;----------------------------------------------------------------------------
;
; File:        tms9900.inc
; Date:        23-Feb-1998
; Programmer:  Marc Rousseau
;
; Description:
;
; Copyright (c) 1998-2000 Marc Rousseau, All Rights Reserved.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
;
; Revision History:
;
;----------------------------------------------------------------------------

_WP_		EQU	ebp
_WPw_		EQU	bp
_PC_		EQU	esi
_PCw_		EQU	si
_ST_		EQU	edx
_STw_		EQU	dx

TMS_LOGICAL	EQU	080h
TMS_ARITHMETIC	EQU	040h
TMS_EQUAL	EQU	020h
TMS_CARRY	EQU	010h
TMS_OVERFLOW	EQU	008h
TMS_PARITY	EQU	004h
TMS_XOP		EQU	002h
		
MEMFLG_READ	EQU	080h
MEMFLG_WRITE	EQU	040h
MEMFLG_ACCESS	EQU	0C0h
MEMFLG_ROM	EQU	020h
			 
MACRO	CallTrapByte	TrapList
	movzx	ebx, bl
	push	edi		
	push	esi
	push	edx
	push	eax
	push	ebx
	movzx	eax, [ _MemFlags + ecx ]
	and	eax, 0000000Fh
	xor	ecx, 1
	push	ecx
	push	[ TrapList + eax * 8 ]
	call	[ TrapList + eax * 8 + 4 ]
	pop	ecx	   
	pop	ecx
	xor	ecx, 1
        pop	ebx
        push	eax
	pop	ebx
	pop	eax
	pop	edx
	pop	esi
	pop	edi
	movsx	ebx, bl
ENDM	CallTrapByte

MACRO	CallTrapWord	TrapList
	push	edi		
	push	esi
	push	edx
	push	eax
        xchg    bh, bl
	push	ebx
	push	ecx
	movzx	eax, [ _MemFlags + ecx ]
	and	eax, 0000000Fh
	push	[ TrapList + eax * 8 ]
	call	[ TrapList + eax * 8 + 4 ]
	pop	ecx	   
	pop	ecx
        pop	ebx
        push	eax
	pop	ebx
        xchg    bh, bl
	pop	eax
	pop	edx
	pop	esi
	pop	edi
ENDM	CallTrapWord
